<?
/*
###############################
#
# CC Scrubber plugin script for CC
# verified with CC versions 1.9x
# http://www.jkirkpatrick.org
#
###############################
#
# Date: Feb 13, 2004
# Web: http://www.jkirkpatrick.org
# Mail: plugins@jkirkpatrick.org
#
####################################
#
#Copyright 2004 Jeremiah Kirkpatrick, All rights Reserved
#
###############################
*/
if(!is_object($this))
exit;
global $mysql_database;
if($_POST['check'])
{
	foreach($_POST['check'] as $key =>$value)
	{
		$result=@mysql_query("CHECK TABLE `$key` CHANGED MEDIUM");
		while($row=@mysql_fetch_array($result))
		{
			if($row['Msg_type']!='status')
				$dbcheck.="<font color=#FF0000>$row[Table] - $row[Op] - $row[Msg_type] - $row[Msg_text]</font><br>\n";
			else
				$dbcheck.="$row[Table] - $row[Op] - $row[Msg_type] - $row[Msg_text]<br>\n";
		}
	}
}
if($_POST['optimize'])
{
	foreach($_POST['optimize'] as $key =>$value)
	{
		$result=@mysql_query("OPTIMIZE TABLE `$key` CHANGED MEDIUM");
		$dbcheck.="Table <b>$key</b> has been optimized.<br>\n";
	}
}
if($_POST['drop'])
{
	foreach($_POST['drop'] as $key =>$value)
	{
		$result=@mysql_query("DROP TABLE `$key`");
		$dbcheck.="<font color=#FF0000>Table <b>$key</b> has been DROPPED.</font><br>\n";
	}
}
if($_POST['repair'])
{
	foreach($_POST['repair'] as $key =>$value)
	{
		$result=@mysql_query("REPAIR TABLE `$key`");
		while($row=@mysql_fetch_array($result))
		{
			if($row['Msg_type']!='status')
				$dbcheck.="<font color=#FF0000>$row[Table] - $row[Op] - $row[Msg_type] - $row[Msg_text]</font><br>\n";
			else
				$dbcheck.="$row[Table] - $row[Op] - $row[Msg_type] - $row[Msg_text]<br>\n";
		}
	}
}
?>
<p align=left>
<?=$dbcheck;?>
</p>
<p align=left>This page will allow you to perform certain database maintenance tasks on your database tables. This page shows any and all tables in this database, not just your Cash Crusader tables. To perform a task simply check the corresponding checkbox next to the table. The following tasks can be performed using this page of the plugin:</p>
<p align=left><b>OPTIMIZE</b>:&nbsp;&nbsp;OPTIMIZE TABLE should be used if you have deleted a large part of a table or if you have made many changes to a table with variable-length rows (tables that have VARCHAR, BLOB, or TEXT columns). Deleted records are maintained in a linked list and subsequent INSERT operations reuse old record positions. You can use OPTIMIZE TABLE to reclaim the unused space and to defragment the datafile. Tables with over 20% of their size unused will automaticly have this box checked.<br>Color Codes: <font color=#00FF00>6-10% unused</font>, <font color=#555500>11-19% unused</font>, <font color=#FF0000>20%+ unused</font><br>
<b>CHECK</b>:&nbsp;&nbsp;Checks the table or tables for errors.<br>
<b>REPAIR</b>:&nbsp;&nbsp;Normally you should never have to run this command, but if disaster strikes, you are very likely to get back all your data from a MyISAM table with REPAIR TABLE. If your tables get corrupted often, you should try to find the reason for it, to eliminate the need to use REPAIR TABLE.<br>
<b>DROP</b>:&nbsp;&nbsp;DROP TABLE removes one or more tables. All table data and the table definition are <em>removed</em>, so <b> be careful </b> with this command! It is marked in a solid red box to help avoid accidents, and don't check this box unless you are prepaired to lose all data stored in the table.</p>
<p align=left><font color=#FF0000>The power of this page should not be taken lightly. All operations performed on this page are "blocking" operations meaning no reads or writes will occur on a table until the function takes it's course. If a table is realy large, or your database is under heavy use, these tools my lag members actively using your site.</font></p>
<form action="<?=$_SERVER['PHP_SELF'];?>" method="POST">
<input type=hidden name=p_load value="<?=$this->class_name;?>">
<input type=hidden name=page value=database>
<table border=0 width=100% align=center>
<tr>
<td colspan=10 align=center><h2>Maintenance Options for Database <?=$mysql_database;?></h2></td>
</tr>
<tr bgcolor=#DDDDDD>
<th align=left valign=top>Table Name</th>
<th align=left valign=top>Row Count</th>
<th align=left valign=top>Avg. Row Size</th>
<th align=left valign=top>Table Size</th>
<th align=left valign=top>Overhead<br>(unused)</th>
<th align=left valign=top>Creation Date/Time</th>
<th align=left valign=top>Last Update Date/Time</th>
<th align=left valign=top>Last Check Date/Time</th>
<th align=left valign=top>Optimize</th>
<th align=left valign=top>Check</th>
<th align=left valign=top bgcolor=#00FFFF>Repair</th>
<th align=left valign=top bgcolor=#FF0000>DROP</th>
</tr>
<?
global $mysql_database;
$table_list=@mysql_list_tables($mysql_database);
for ($i = 0; $i < @mysql_num_rows($table_list); $i++)
{
	$table=@mysql_tablename($table_list, $i);
	$row=@mysql_fetch_array(@mysql_query("SHOW TABLE STATUS FROM ".$mysql_database." LIKE '$table'"));
?>
<tr bgcolor=#DDDDDD>
<td align=left valign=top><?=$row['Name'];?></td>
<td align=left valign=top><?=$row['Rows'];?></td>
<td align=left valign=top><?=$row['Avg_row_length'];?></td>
<td align=left valign=top><?=$row['Data_length'];?></td>
<td align=left valign=top><?
if($row['Data_free'] > ($row['Data_length']/5))
	{
		echo "<font color=#FF0000>$row[Data_free]</font>\n";
		$checked='checked';
	}
else if ($row['Data_free'] > ($row['Data_length']/10))
	{
		echo "<font color=#555500>$row[Data_free]</font>\n";
		$checked='';
	}
else if ($row['Data_free'] > ($row['Data_length']/20))
	{
		echo "<font color=#00FF00>$row[Data_free]</font>\n";
		$checked='';
	}
else
	{
		echo $row['Data_free'];
		$checked='';
	}
?></td>
<td align=left valign=top><?=$row['Create_time'];?></td>
<td align=left valign=top><?=$row['Update_time'];?></td>
<td align=left valign=top><?=$row['Check_time'];?></td>
<td align=left valign=top><input type=checkbox name=optimize[<?=$row['Name'];?>] <?=$checked;?>></td>
<td align=left valign=top><input type=checkbox name=check[<?=$row['Name'];?>]></td>
<td align=left valign=top bgcolor=#00FFFF><input type=checkbox name=repair[<?=$row['Name'];?>]></td>
<td align=left valign=top bgcolor=#FF0000><input type=checkbox name=drop[<?=$row['Name'];?>]></td>
</tr>
<?
}
?>
<tr>
<td colspan=10 align=center valign=top><input type=submit name=submit value="Perform Maintenance"></td>
</tr>
</table>
</form>
