<?
/*
###############################
#
# CC Scrubber plugin script for CC
# verified with CC versions 1.9x
# http://www.jkirkpatrick.org
#
###############################
#
# Date: Feb 13, 2004
# Web: http://www.jkirkpatrick.org
# Mail: plugins@jkirkpatrick.org
#
####################################
# This script is copyright 2004 by Jeremiah Kirkpatrick,
# All Rights Reserved.
#
# The use of this script constitutes acceptance of any terms or conditions,
# See license.txt for details
#
#################################
02/25/04 - Date bug in Resends 'since last click' column.
02/25/04 - Addition of the accounting scrubber.
03/01/04 - Banner management bug fix
03/01/04 - Path deturmination update
03/02/04 - Update notification
03/03/04 - Global Session bug Fix
06/05/04 - Addition of Auto Surf Maintenance
06/05/04 - Brought Current with latest standards.
06/05/04 - Fixed orphaned account entry deletion bug
02/21/05 - Backend Updates
06/02/05 - Brought up to speed with php5
12/10/05 - Freeware Release
*/
$plugins[]=array("name"=>"CC Scrubber", "classname"=>"cc_scrubber");
class cc_scrubber extends plugin_base
{
	var $class_name = "cc_scrubber";
	var $path = 'scrubber/';
	var $author = "Jeremiah K.";
	var $web = "http://www.jkirkpatrick.org/";
	var $name = "CC Scrubber (Freeware)";
	var $date = "12-08-05";
	var $table = "cc_scrubber";
	var $version = '1.20';
	var $status;
	var $menu;
	var $file_name;
	function cc_scrubber()
	{
		global $mysql_database;
		$this->table = mysql_prefix.$this->table;
		$this->path=dirname(__FILE__).'/';
	}
	function admin_page()
	{
		global $HTTP_SESSION_VARS;
		if($_GET['page']) $load=&$_GET['page'];
		if($_POST['page']) $load=&$_POST['page'];
		$this->menu="<h1 align=center>$this->name</h1>
		<p align=center><a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name\">Main</a>&nbsp;|&nbsp;
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=emails\">eMails</a>&nbsp;|&nbsp;
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=email_ads\">eMail Ads</a>&nbsp;|&nbsp;
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=banners\">Rotating Banners</a>&nbsp;|&nbsp;
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=ptc\">Paid to Clicks</a>&nbsp;|&nbsp;
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=autosurf\">Auto Surf</a>&nbsp;|&nbsp;
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=accounting\">Accounting</a><br>
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=database\">Database Operations</a>&nbsp;|&nbsp;
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=about\">About</a>&nbsp;|&nbsp;
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=readme\">Read Me</a>\n";
		echo $this->menu.$this->status;
		if(method_exists($this, $load))
		{call_user_func(array($this, $load));$this->page_footer();return;}
		$this->load_page($this->path.'main.admin.php', 0);
		$this->page_footer();
	}
	function load_page($page, $style=0)
	{
		switch($style)
		{
			case '0':
			if(file_exists($page))
				include($page);
			else
				echo "<font color=#FF0000>Missing or renamed required configuration file!($page)</font>\n";
			break;
			case '1':
			if(file_exists($page))
			{
				echo "<textarea cols=90 rows=40>\n";
				include($page);
				echo "</textarea>\n";
			}
			else
				echo "<font color=#FF0000>Missing or renamed required configuration file!($page)</font>\n";
			break;
		}
	}
	function public_page()
	{

	}
	function readme()
	{
		$this->load_page($this->path.'README', 1);
	}
	function about()
	{
		$this->load_page($this->path.'about.admin.php', 0);
	}
	function emails()
	{
		$this->load_page($this->path.'emails.admin.php', 0);
	}
	function email_ads()
	{
		$this->load_page($this->path.'email_ads.admin.php', 0);
	}
	function accounting()
	{
		$this->load_page($this->path.'accounting.admin.php', 0);
	}
	function ptc()
	{
		$this->load_page($this->path.'ptc.admin.php', 0);
	}
	function autosurf()
	{
		$this->load_page($this->path.'autosurf.admin.php', 0);
	}
	function banners()
	{
		$this->load_page($this->path.'banners.admin.php', 0);
	}
	function database()
	{
		$this->load_page($this->path.'database.admin.php', 0);
	}
	function chk_orphaned_tables()
	{
		global $mysql_database;
		$table_list=@mysql_list_tables($mysql_database);
		$x=0;
		for ($i = 0; $i < @mysql_num_rows($table_list); $i++)
		{
		   $table=@mysql_tablename($table_list, $i);
			if(strpos($table,"paid_clicks_")===0)
			{
				$chkid=substr($table,12);
				if(!@mysql_num_rows(@mysql_query("select `emailid` from ".mysql_prefix."email_ads where emailid=$chkid")))
				{
					$orphaned[$x]='paid_clicks_'.$chkid;
					$x++;
				}
			}
		}
		return $orphaned;
	}
	function drop_table($table)
	{
		return $results=@mysql_query("DROP TABLE `$table`");
	}
	function optimize_table($table)
	{
		return $results=@mysql_query("OPTIMIZE TABLE `$table`");
	}
	function check_table($table)
	{
		$results=@mysql_query("CHECK TABLE `$table` CHANGED MEDIUM");
		while($row=@mysql_fetch_array($results))
		{
			if($row['Msg_type']!='status')
				$msg.="<font color=#FF0000>$row[Table] - $row[Op] - $row[Msg_type] - $row[Msg_text]</font><br>\n";
			else
				$msg.="$row[Table] - $row[Op] - $row[Msg_type] - $row[Msg_text]<br>";
		}
		return $msg;
	}
	function day_laps($date_last)
	{
		$last_click=time()-$date_last;
		$tmp=$last_click;
		$tmp=intval($tmp/60);
		$tmp=intval($tmp/60);
		$days=intval($tmp/24);
		return $days;
	}
	function ccdate2nix($date)
	{
		if(strlen($date)<14)
			$date=str_pad($date, 14, '0');
		$year[0]=$date[0];
		$year[1]=$date[1];
		$year[2]=$date[2];
		$year[3]=$date[3];
		$month[0]=$date[4];
		$month[1]=$date[5];
		$day[0]=$date[6];
		$day[1]=$date[7];
		$hour[0]=$date[8];
		$hour[1]=$date[9];
		$minute[0]=$date[10];
		$minute[1]=$date[11];
		$second[0]=$date[12];
		$second[1]=$date[13];
		$year=implode('', $year);
		$month=implode('', $month);
		$day=implode('', $day);
		$hour=implode('', $hour);
		$minute=implode('', $minute);
		$second=implode('', $second);
 		$date=gmmktime($hour, $minute, $second, $month, $day, $year);
		return $date;
	}
	function chk_date($date_expire)
	{
		$now=time();
		$date_expire=$this->ccdate2nix($date_expire);
		if($date_expire-$now<0)
			return TRUE;
		else
			return FALSE;
	}
	function page_footer()
	{
		echo '<hr width=80%><table border="0" width="100%" align="center">
<tr bgcolor="#DDDDDD">
<td align="left" colspan="2"><p>These plugins are now offered as freeware to anybody who wishes to use them. </td></tr>';
	/*BEGIN COPYRIGHT NOTICE*/
	/*WARNING: TAMPERING WITH THIS SECTION OF CODE OR OTHERWISE CIRCUMVENTING IT'S EXECUTION BY BLOCKING OR REMOVING THE FUNCTION CALLS IS A VIOLATION IN THE FREEWARE LICENSE AGREEMENT WHICH GOVERNS YOUR USE OF THIS SCRIPT.*/
echo '<tr>
<td colspan="2" align="center">
'.$this->name.'<br>
&copy;2006 JKirkpatrick, All Rights Reserved<br>
</td>
</tr>';
	/*END COPYRIGHT NOTICE*/
echo '</table>';
	}
}
